/* taquin-view.c generated by valac 0.44.0, the Vala compiler
 * generated from taquin-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2014-2016 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 *
 * This file is part of Taquin.
 *
 * Taquin is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Taquin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Taquin. If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

typedef enum  {
	DIRECTION_TOP,
	DIRECTION_LEFT,
	DIRECTION_RIGHT,
	DIRECTION_BOTTOM,
	DIRECTION_NONE
} Direction;

#define TYPE_DIRECTION (direction_get_type ())

#define TYPE_TAQUIN_VIEW (taquin_view_get_type ())
#define TAQUIN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAQUIN_VIEW, TaquinView))
#define TAQUIN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAQUIN_VIEW, TaquinViewClass))
#define IS_TAQUIN_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAQUIN_VIEW))
#define IS_TAQUIN_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAQUIN_VIEW))
#define TAQUIN_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAQUIN_VIEW, TaquinViewClass))

typedef struct _TaquinView TaquinView;
typedef struct _TaquinViewClass TaquinViewClass;
typedef struct _TaquinViewPrivate TaquinViewPrivate;

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
enum  {
	TAQUIN_VIEW_0_PROPERTY,
	TAQUIN_VIEW_GAME_PROPERTY,
	TAQUIN_VIEW_THEME_PROPERTY,
	TAQUIN_VIEW_NUM_PROPERTIES
};
static GParamSpec* taquin_view_properties[TAQUIN_VIEW_NUM_PROPERTIES];
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef enum  {
	GAME_TYPE_FIFTEEN,
	GAME_TYPE_SIXTEEN
} GameType;

#define TYPE_GAME_TYPE (game_type_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TaquinView {
	GtkDrawingArea parent_instance;
	TaquinViewPrivate * priv;
};

struct _TaquinViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _TaquinViewPrivate {
	gint grid_border_main;
	gint grid_border_thin;
	gint arrows;
	gint tile_size;
	gint board_size;
	gint8 x_arrow;
	gint8 y_arrow;
	gboolean draw_lights;
	gint render_size;
	cairo_pattern_t* tiles_pattern;
	gboolean animate;
	gint animation_offset;
	gboolean x_axis;
	gint number;
	gint8 x_gap;
	gint8 y_gap;
	gboolean animate_end;
	gboolean finished;
	gdouble animation_end_offset;
	Game* _game;
	gchar* _theme;
};

static gint TaquinView_private_offset;
static gpointer taquin_view_parent_class = NULL;

GType direction_get_type (void) G_GNUC_CONST;
GType taquin_view_get_type (void) G_GNUC_CONST;
GType game_get_type (void) G_GNUC_CONST;
#define TAQUIN_VIEW_GRID_SPACING 1
#define TAQUIN_VIEW_half_pi (G_PI / 2.0)
#define TAQUIN_VIEW_three_half_pi (TAQUIN_VIEW_half_pi * 3.0)
static void taquin_view_calculate (TaquinView* self);
static Game* taquin_view_get_game (TaquinView* self);
gint8 game_get_size (Game* self);
TaquinView* taquin_view_new (void);
TaquinView* taquin_view_construct (GType object_type);
static gboolean taquin_view_real_draw (GtkWidget* base,
                                cairo_t* cr);
static inline void _taquin_view_load_image (cairo_t* c,
                              const gchar* theme,
                              gint* board_size);
static const gchar* taquin_view_get_theme (TaquinView* self);
static gint taquin_view_get_x_offset (TaquinView* self);
static gint taquin_view_get_y_offset (TaquinView* self);
static inline void _taquin_view_draw_board (cairo_t* cr,
                              gint* grid_border_main,
                              gint* board_size,
                              gint* grid_border_thin);
GType game_type_get_type (void) G_GNUC_CONST;
GameType game_get_game_type (Game* self);
static inline void taquin_view_draw_movable_lights (TaquinView* self,
                                      cairo_t* cr);
static inline void taquin_view_draw_fixed_arrows (TaquinView* self,
                                    cairo_t* cr);
static inline void taquin_view_draw_movable_arrows (TaquinView* self,
                                      cairo_t* cr);
gint8 game_get_tile_value (Game* self,
                           gint8 x,
                           gint8 y);
static inline void _taquin_view_draw_movable_lights (cairo_t* cr,
                                       gdouble* animation_end_offset,
                                       gint* grid_border_main,
                                       gint* tile_size,
                                       gint8* x_arrow,
                                       gint* grid_border_thin,
                                       gint* board_size,
                                       gint8* y_arrow);
static void taquin_view_draw_light (cairo_t* cr,
                             gboolean horizontal,
                             gint* tile_size,
                             gint* grid_border_main);
static inline void _taquin_view_draw_fixed_arrows (cairo_t* cr,
                                     gint game_size,
                                     gint* grid_border_main,
                                     gint* tile_size,
                                     gint* grid_border_thin,
                                     gint* board_size);
static void taquin_view_draw_vertical_arrow (cairo_t* cr,
                                      gboolean inside,
                                      gint number,
                                      gint* grid_border_main,
                                      gint* tile_size,
                                      gint* grid_border_thin,
                                      gint* board_size);
static void taquin_view_draw_horizontal_arrow (cairo_t* cr,
                                        gboolean inside,
                                        gint number,
                                        gint* grid_border_main,
                                        gint* tile_size,
                                        gint* grid_border_thin,
                                        gint* board_size);
static inline void _taquin_view_draw_movable_arrows (cairo_t* cr,
                                       gint8* x_arrow,
                                       gint8* y_arrow,
                                       gint* grid_border_main,
                                       gint* tile_size,
                                       gint* grid_border_thin,
                                       gint* board_size);
static void taquin_view_move_cb (TaquinView* self,
                          gboolean x_axis,
                          gint8 number,
                          gint8 x_gap,
                          gint8 y_gap,
                          guint moves_count,
                          gboolean disable_animation);
static void taquin_view_complete_cb (TaquinView* self);
static gboolean __lambda13_ (TaquinView* self);
static gboolean ___lambda13__gsource_func (gpointer self);
static gboolean taquin_view_real_button_press_event (GtkWidget* base,
                                              GdkEventButton* event);
void game_request_move (Game* self,
                        gint8 x,
                        gint8 y,
                        gboolean keyboard_call);
static gboolean taquin_view_real_key_press_event (GtkWidget* base,
                                           GdkEventKey* event);
void taquin_view_set_game (TaquinView* self,
                           Game* value);
static void _taquin_view_move_cb_game_move (Game* _sender,
                                     gboolean x_axis,
                                     gint8 number,
                                     gint8 x_gap,
                                     gint8 y_gap,
                                     guint moves_count,
                                     gboolean disable_animation,
                                     gpointer self);
static void _taquin_view_complete_cb_game_complete (Game* _sender,
                                             gpointer self);
void taquin_view_set_theme (TaquinView* self,
                            const gchar* value);
static void taquin_view_finalize (GObject * obj);
static void _vala_taquin_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_taquin_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

GType
direction_get_type (void)
{
	static volatile gsize direction_type_id__volatile = 0;
	if (g_once_init_enter (&direction_type_id__volatile)) {
		static const GEnumValue values[] = {{DIRECTION_TOP, "DIRECTION_TOP", "top"}, {DIRECTION_LEFT, "DIRECTION_LEFT", "left"}, {DIRECTION_RIGHT, "DIRECTION_RIGHT", "right"}, {DIRECTION_BOTTOM, "DIRECTION_BOTTOM", "bottom"}, {DIRECTION_NONE, "DIRECTION_NONE", "none"}, {0, NULL, NULL}};
		GType direction_type_id;
		direction_type_id = g_enum_register_static ("Direction", values);
		g_once_init_leave (&direction_type_id__volatile, direction_type_id);
	}
	return direction_type_id__volatile;
}

static inline gpointer
taquin_view_get_instance_private (TaquinView* self)
{
	return G_STRUCT_MEMBER_P (self, TaquinView_private_offset);
}

static void
taquin_view_calculate (TaquinView* self)
{
	gint size = 0;
	Game* _tmp0_;
	Game* _tmp1_;
	gint8 _tmp2_;
	gint8 _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
	gint8 _tmp6_;
	gint8 _tmp7_;
#line 46 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/taquin-view.vala"
	size = MIN (gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self));
#line 50 "../src/taquin-view.vala"
	_tmp0_ = taquin_view_get_game (self);
#line 50 "../src/taquin-view.vala"
	_tmp1_ = _tmp0_;
#line 50 "../src/taquin-view.vala"
	_tmp2_ = game_get_size (_tmp1_);
#line 50 "../src/taquin-view.vala"
	_tmp3_ = _tmp2_;
#line 50 "../src/taquin-view.vala"
	self->priv->tile_size = ((size * 10) / 12) / _tmp3_;
#line 51 "../src/taquin-view.vala"
	_tmp4_ = taquin_view_get_game (self);
#line 51 "../src/taquin-view.vala"
	_tmp5_ = _tmp4_;
#line 51 "../src/taquin-view.vala"
	_tmp6_ = game_get_size (_tmp5_);
#line 51 "../src/taquin-view.vala"
	_tmp7_ = _tmp6_;
#line 51 "../src/taquin-view.vala"
	self->priv->board_size = (self->priv->tile_size * _tmp7_) - TAQUIN_VIEW_GRID_SPACING;
#line 52 "../src/taquin-view.vala"
	self->priv->grid_border_main = (size - self->priv->board_size) / 2;
#line 53 "../src/taquin-view.vala"
	self->priv->arrows = size / 100;
#line 296 "taquin-view.c"
}

TaquinView*
taquin_view_construct (GType object_type)
{
	TaquinView * self = NULL;
#line 76 "../src/taquin-view.vala"
	self = (TaquinView*) g_object_new (object_type, NULL);
#line 78 "../src/taquin-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 79 "../src/taquin-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (gint) (((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_KEY_PRESS_MASK));
#line 76 "../src/taquin-view.vala"
	return self;
#line 311 "taquin-view.c"
}

TaquinView*
taquin_view_new (void)
{
#line 76 "../src/taquin-view.vala"
	return taquin_view_construct (TYPE_TAQUIN_VIEW);
#line 319 "taquin-view.c"
}

static gboolean
taquin_view_real_draw (GtkWidget* base,
                       cairo_t* cr)
{
	TaquinView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	cairo_pattern_t* _tmp1_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	Game* _tmp15_;
	Game* _tmp16_;
	GameType _tmp17_;
	GameType _tmp18_;
	gboolean _tmp19_ = FALSE;
#line 122 "../src/taquin-view.vala"
	self = (TaquinView*) base;
#line 122 "../src/taquin-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 127 "../src/taquin-view.vala"
	taquin_view_calculate (self);
#line 129 "../src/taquin-view.vala"
	_tmp1_ = self->priv->tiles_pattern;
#line 129 "../src/taquin-view.vala"
	if (_tmp1_ == NULL) {
#line 129 "../src/taquin-view.vala"
		_tmp0_ = TRUE;
#line 351 "taquin-view.c"
	} else {
#line 129 "../src/taquin-view.vala"
		_tmp0_ = self->priv->render_size != self->priv->tile_size;
#line 355 "taquin-view.c"
	}
#line 129 "../src/taquin-view.vala"
	if (_tmp0_) {
#line 359 "taquin-view.c"
		cairo_surface_t* surface = NULL;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
		cairo_t* c = NULL;
		cairo_surface_t* _tmp4_;
		cairo_t* _tmp5_;
		cairo_t* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_pattern_t* _tmp10_;
#line 131 "../src/taquin-view.vala"
		self->priv->render_size = self->priv->tile_size;
#line 132 "../src/taquin-view.vala"
		_tmp2_ = cairo_get_target (cr);
#line 132 "../src/taquin-view.vala"
		_tmp3_ = cairo_surface_create_similar (_tmp2_, CAIRO_CONTENT_COLOR_ALPHA, self->priv->board_size, self->priv->board_size);
#line 132 "../src/taquin-view.vala"
		surface = _tmp3_;
#line 133 "../src/taquin-view.vala"
		_tmp4_ = surface;
#line 133 "../src/taquin-view.vala"
		_tmp5_ = cairo_create (_tmp4_);
#line 133 "../src/taquin-view.vala"
		c = _tmp5_;
#line 134 "../src/taquin-view.vala"
		_tmp6_ = c;
#line 134 "../src/taquin-view.vala"
		_tmp7_ = taquin_view_get_theme (self);
#line 134 "../src/taquin-view.vala"
		_tmp8_ = _tmp7_;
#line 134 "../src/taquin-view.vala"
		_taquin_view_load_image (_tmp6_, _tmp8_, &self->priv->board_size);
#line 135 "../src/taquin-view.vala"
		_tmp9_ = surface;
#line 135 "../src/taquin-view.vala"
		_tmp10_ = cairo_pattern_create_for_surface (_tmp9_);
#line 135 "../src/taquin-view.vala"
		_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 135 "../src/taquin-view.vala"
		self->priv->tiles_pattern = _tmp10_;
#line 129 "../src/taquin-view.vala"
		_cairo_destroy0 (c);
#line 129 "../src/taquin-view.vala"
		_cairo_surface_destroy0 (surface);
#line 405 "taquin-view.c"
	}
#line 138 "../src/taquin-view.vala"
	_tmp11_ = taquin_view_get_x_offset (self);
#line 138 "../src/taquin-view.vala"
	_tmp12_ = _tmp11_;
#line 138 "../src/taquin-view.vala"
	_tmp13_ = taquin_view_get_y_offset (self);
#line 138 "../src/taquin-view.vala"
	_tmp14_ = _tmp13_;
#line 138 "../src/taquin-view.vala"
	cairo_translate (cr, (gdouble) _tmp12_, (gdouble) _tmp14_);
#line 139 "../src/taquin-view.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 140 "../src/taquin-view.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 142 "../src/taquin-view.vala"
	_taquin_view_draw_board (cr, &self->priv->grid_border_main, &self->priv->board_size, &self->priv->grid_border_thin);
#line 145 "../src/taquin-view.vala"
	cairo_set_source_rgba (cr, 0.5, 0.5, 0.5, 1.0 - self->priv->animation_end_offset);
#line 146 "../src/taquin-view.vala"
	cairo_set_line_width (cr, (gdouble) self->priv->arrows);
#line 147 "../src/taquin-view.vala"
	_tmp15_ = taquin_view_get_game (self);
#line 147 "../src/taquin-view.vala"
	_tmp16_ = _tmp15_;
#line 147 "../src/taquin-view.vala"
	_tmp17_ = game_get_game_type (_tmp16_);
#line 147 "../src/taquin-view.vala"
	_tmp18_ = _tmp17_;
#line 147 "../src/taquin-view.vala"
	if (_tmp18_ == GAME_TYPE_SIXTEEN) {
#line 149 "../src/taquin-view.vala"
		if (self->priv->draw_lights) {
#line 150 "../src/taquin-view.vala"
			taquin_view_draw_movable_lights (self, cr);
#line 441 "taquin-view.c"
		}
#line 151 "../src/taquin-view.vala"
		taquin_view_draw_fixed_arrows (self, cr);
#line 445 "taquin-view.c"
	} else {
#line 154 "../src/taquin-view.vala"
		taquin_view_draw_movable_arrows (self, cr);
#line 449 "taquin-view.c"
	}
#line 155 "../src/taquin-view.vala"
	cairo_stroke (cr);
#line 158 "../src/taquin-view.vala"
	cairo_save (cr);
#line 159 "../src/taquin-view.vala"
	cairo_translate (cr, (gdouble) self->priv->grid_border_main, (gdouble) self->priv->grid_border_main);
#line 161 "../src/taquin-view.vala"
	if (self->priv->animate) {
#line 459 "taquin-view.c"
		Game* _tmp20_;
		Game* _tmp21_;
		GameType _tmp22_;
		GameType _tmp23_;
#line 161 "../src/taquin-view.vala"
		_tmp20_ = taquin_view_get_game (self);
#line 161 "../src/taquin-view.vala"
		_tmp21_ = _tmp20_;
#line 161 "../src/taquin-view.vala"
		_tmp22_ = game_get_game_type (_tmp21_);
#line 161 "../src/taquin-view.vala"
		_tmp23_ = _tmp22_;
#line 161 "../src/taquin-view.vala"
		_tmp19_ = _tmp23_ == GAME_TYPE_SIXTEEN;
#line 474 "taquin-view.c"
	} else {
#line 161 "../src/taquin-view.vala"
		_tmp19_ = FALSE;
#line 478 "taquin-view.c"
	}
#line 161 "../src/taquin-view.vala"
	if (_tmp19_) {
#line 482 "taquin-view.c"
		gint texture_x = 0;
		Game* _tmp24_;
		Game* _tmp25_;
		Game* _tmp26_;
		Game* _tmp27_;
		gint8 _tmp28_;
		gint8 _tmp29_;
		gint texture_y = 0;
		Game* _tmp30_;
		Game* _tmp31_;
		Game* _tmp32_;
		Game* _tmp33_;
		gint8 _tmp34_;
		gint8 _tmp35_;
		gint tile_x = 0;
		gint tile_y = 0;
		cairo_matrix_t matrix = {0};
		cairo_pattern_t* _tmp36_;
		cairo_matrix_t _tmp37_;
		cairo_pattern_t* _tmp38_;
		gint _tmp39_ = 0;
		gint8 _tmp45_ = 0;
		cairo_pattern_t* _tmp51_;
		cairo_matrix_t _tmp52_;
		cairo_pattern_t* _tmp53_;
#line 163 "../src/taquin-view.vala"
		_tmp24_ = taquin_view_get_game (self);
#line 163 "../src/taquin-view.vala"
		_tmp25_ = _tmp24_;
#line 163 "../src/taquin-view.vala"
		_tmp26_ = taquin_view_get_game (self);
#line 163 "../src/taquin-view.vala"
		_tmp27_ = _tmp26_;
#line 163 "../src/taquin-view.vala"
		_tmp28_ = game_get_size (_tmp27_);
#line 163 "../src/taquin-view.vala"
		_tmp29_ = _tmp28_;
#line 163 "../src/taquin-view.vala"
		texture_x = (game_get_tile_value (_tmp25_, self->priv->x_gap, self->priv->y_gap) % _tmp29_) * self->priv->tile_size;
#line 164 "../src/taquin-view.vala"
		_tmp30_ = taquin_view_get_game (self);
#line 164 "../src/taquin-view.vala"
		_tmp31_ = _tmp30_;
#line 164 "../src/taquin-view.vala"
		_tmp32_ = taquin_view_get_game (self);
#line 164 "../src/taquin-view.vala"
		_tmp33_ = _tmp32_;
#line 164 "../src/taquin-view.vala"
		_tmp34_ = game_get_size (_tmp33_);
#line 164 "../src/taquin-view.vala"
		_tmp35_ = _tmp34_;
#line 164 "../src/taquin-view.vala"
		texture_y = (game_get_tile_value (_tmp31_, self->priv->x_gap, self->priv->y_gap) / _tmp35_) * self->priv->tile_size;
#line 167 "../src/taquin-view.vala"
		tile_x = self->priv->x_gap * self->priv->tile_size;
#line 168 "../src/taquin-view.vala"
		tile_y = self->priv->y_gap * self->priv->tile_size;
#line 170 "../src/taquin-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 171 "../src/taquin-view.vala"
		cairo_matrix_translate (&matrix, (gdouble) (texture_x - tile_x), (gdouble) (texture_y - tile_y));
#line 172 "../src/taquin-view.vala"
		_tmp36_ = self->priv->tiles_pattern;
#line 172 "../src/taquin-view.vala"
		_tmp37_ = matrix;
#line 172 "../src/taquin-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp36_, &_tmp37_);
#line 173 "../src/taquin-view.vala"
		_tmp38_ = self->priv->tiles_pattern;
#line 173 "../src/taquin-view.vala"
		cairo_set_source (cr, (cairo_pattern_t*) _tmp38_);
#line 174 "../src/taquin-view.vala"
		cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING), (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING));
#line 175 "../src/taquin-view.vala"
		cairo_fill (cr);
#line 178 "../src/taquin-view.vala"
		if (self->priv->x_axis) {
#line 560 "taquin-view.c"
			gint _tmp40_ = 0;
#line 178 "../src/taquin-view.vala"
			if (((gint) self->priv->x_gap) == 0) {
#line 564 "taquin-view.c"
				Game* _tmp41_;
				Game* _tmp42_;
				gint8 _tmp43_;
				gint8 _tmp44_;
#line 178 "../src/taquin-view.vala"
				_tmp41_ = taquin_view_get_game (self);
#line 178 "../src/taquin-view.vala"
				_tmp42_ = _tmp41_;
#line 178 "../src/taquin-view.vala"
				_tmp43_ = game_get_size (_tmp42_);
#line 178 "../src/taquin-view.vala"
				_tmp44_ = _tmp43_;
#line 178 "../src/taquin-view.vala"
				_tmp40_ = _tmp44_ - 1;
#line 579 "taquin-view.c"
			} else {
#line 178 "../src/taquin-view.vala"
				_tmp40_ = 0;
#line 583 "taquin-view.c"
			}
#line 178 "../src/taquin-view.vala"
			_tmp39_ = _tmp40_;
#line 587 "taquin-view.c"
		} else {
#line 178 "../src/taquin-view.vala"
			_tmp39_ = (gint) self->priv->x_gap;
#line 591 "taquin-view.c"
		}
#line 178 "../src/taquin-view.vala"
		tile_x = self->priv->tile_size * _tmp39_;
#line 179 "../src/taquin-view.vala"
		if (self->priv->x_axis) {
#line 179 "../src/taquin-view.vala"
			_tmp45_ = self->priv->y_gap;
#line 599 "taquin-view.c"
		} else {
			gint _tmp46_ = 0;
#line 179 "../src/taquin-view.vala"
			if (((gint) self->priv->y_gap) == 0) {
#line 604 "taquin-view.c"
				Game* _tmp47_;
				Game* _tmp48_;
				gint8 _tmp49_;
				gint8 _tmp50_;
#line 179 "../src/taquin-view.vala"
				_tmp47_ = taquin_view_get_game (self);
#line 179 "../src/taquin-view.vala"
				_tmp48_ = _tmp47_;
#line 179 "../src/taquin-view.vala"
				_tmp49_ = game_get_size (_tmp48_);
#line 179 "../src/taquin-view.vala"
				_tmp50_ = _tmp49_;
#line 179 "../src/taquin-view.vala"
				_tmp46_ = _tmp50_ - 1;
#line 619 "taquin-view.c"
			} else {
#line 179 "../src/taquin-view.vala"
				_tmp46_ = 0;
#line 623 "taquin-view.c"
			}
#line 179 "../src/taquin-view.vala"
			_tmp45_ = (gint8) _tmp46_;
#line 627 "taquin-view.c"
		}
#line 179 "../src/taquin-view.vala"
		tile_y = self->priv->tile_size * _tmp45_;
#line 181 "../src/taquin-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 182 "../src/taquin-view.vala"
		cairo_matrix_translate (&matrix, (gdouble) (texture_x - tile_x), (gdouble) (texture_y - tile_y));
#line 183 "../src/taquin-view.vala"
		_tmp51_ = self->priv->tiles_pattern;
#line 183 "../src/taquin-view.vala"
		_tmp52_ = matrix;
#line 183 "../src/taquin-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp51_, &_tmp52_);
#line 184 "../src/taquin-view.vala"
		_tmp53_ = self->priv->tiles_pattern;
#line 184 "../src/taquin-view.vala"
		cairo_set_source (cr, (cairo_pattern_t*) _tmp53_);
#line 185 "../src/taquin-view.vala"
		cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING), (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING));
#line 186 "../src/taquin-view.vala"
		cairo_fill (cr);
#line 649 "taquin-view.c"
	}
	{
		gint y = 0;
#line 189 "../src/taquin-view.vala"
		y = 0;
#line 655 "taquin-view.c"
		{
			gboolean _tmp54_ = FALSE;
#line 189 "../src/taquin-view.vala"
			_tmp54_ = TRUE;
#line 189 "../src/taquin-view.vala"
			while (TRUE) {
#line 662 "taquin-view.c"
				Game* _tmp56_;
				Game* _tmp57_;
				gint8 _tmp58_;
				gint8 _tmp59_;
#line 189 "../src/taquin-view.vala"
				if (!_tmp54_) {
#line 669 "taquin-view.c"
					gint _tmp55_;
#line 189 "../src/taquin-view.vala"
					_tmp55_ = y;
#line 189 "../src/taquin-view.vala"
					y = _tmp55_ + 1;
#line 675 "taquin-view.c"
				}
#line 189 "../src/taquin-view.vala"
				_tmp54_ = FALSE;
#line 189 "../src/taquin-view.vala"
				_tmp56_ = taquin_view_get_game (self);
#line 189 "../src/taquin-view.vala"
				_tmp57_ = _tmp56_;
#line 189 "../src/taquin-view.vala"
				_tmp58_ = game_get_size (_tmp57_);
#line 189 "../src/taquin-view.vala"
				_tmp59_ = _tmp58_;
#line 189 "../src/taquin-view.vala"
				if (!(y < ((gint) _tmp59_))) {
#line 189 "../src/taquin-view.vala"
					break;
#line 691 "taquin-view.c"
				}
				{
					gint x = 0;
#line 191 "../src/taquin-view.vala"
					x = 0;
#line 697 "taquin-view.c"
					{
						gboolean _tmp60_ = FALSE;
#line 191 "../src/taquin-view.vala"
						_tmp60_ = TRUE;
#line 191 "../src/taquin-view.vala"
						while (TRUE) {
#line 704 "taquin-view.c"
							Game* _tmp62_;
							Game* _tmp63_;
							gint8 _tmp64_;
							gint8 _tmp65_;
							gboolean _tmp66_ = FALSE;
							gboolean _tmp67_ = FALSE;
							gint tile_x = 0;
							gint tile_y = 0;
							gboolean _tmp68_ = FALSE;
							gint texture_x = 0;
							Game* _tmp80_;
							Game* _tmp81_;
							Game* _tmp82_;
							Game* _tmp83_;
							gint8 _tmp84_;
							gint8 _tmp85_;
							gint texture_y = 0;
							Game* _tmp86_;
							Game* _tmp87_;
							Game* _tmp88_;
							Game* _tmp89_;
							gint8 _tmp90_;
							gint8 _tmp91_;
							cairo_matrix_t matrix = {0};
							cairo_pattern_t* _tmp92_;
							cairo_matrix_t _tmp93_;
							cairo_pattern_t* _tmp94_;
#line 191 "../src/taquin-view.vala"
							if (!_tmp60_) {
#line 734 "taquin-view.c"
								gint _tmp61_;
#line 191 "../src/taquin-view.vala"
								_tmp61_ = x;
#line 191 "../src/taquin-view.vala"
								x = _tmp61_ + 1;
#line 740 "taquin-view.c"
							}
#line 191 "../src/taquin-view.vala"
							_tmp60_ = FALSE;
#line 191 "../src/taquin-view.vala"
							_tmp62_ = taquin_view_get_game (self);
#line 191 "../src/taquin-view.vala"
							_tmp63_ = _tmp62_;
#line 191 "../src/taquin-view.vala"
							_tmp64_ = game_get_size (_tmp63_);
#line 191 "../src/taquin-view.vala"
							_tmp65_ = _tmp64_;
#line 191 "../src/taquin-view.vala"
							if (!(x < ((gint) _tmp65_))) {
#line 191 "../src/taquin-view.vala"
								break;
#line 756 "taquin-view.c"
							}
#line 193 "../src/taquin-view.vala"
							if (self->priv->animate) {
#line 193 "../src/taquin-view.vala"
								_tmp67_ = x == ((gint) self->priv->x_gap);
#line 762 "taquin-view.c"
							} else {
#line 193 "../src/taquin-view.vala"
								_tmp67_ = FALSE;
#line 766 "taquin-view.c"
							}
#line 193 "../src/taquin-view.vala"
							if (_tmp67_) {
#line 193 "../src/taquin-view.vala"
								_tmp66_ = y == ((gint) self->priv->y_gap);
#line 772 "taquin-view.c"
							} else {
#line 193 "../src/taquin-view.vala"
								_tmp66_ = FALSE;
#line 776 "taquin-view.c"
							}
#line 193 "../src/taquin-view.vala"
							if (_tmp66_) {
#line 194 "../src/taquin-view.vala"
								continue;
#line 782 "taquin-view.c"
							}
#line 196 "../src/taquin-view.vala"
							tile_x = x * self->priv->tile_size;
#line 197 "../src/taquin-view.vala"
							tile_y = y * self->priv->tile_size;
#line 199 "../src/taquin-view.vala"
							if (self->priv->animate) {
#line 790 "taquin-view.c"
								gboolean _tmp69_ = FALSE;
#line 199 "../src/taquin-view.vala"
								if (x != ((gint) self->priv->x_gap)) {
#line 199 "../src/taquin-view.vala"
									_tmp69_ = TRUE;
#line 796 "taquin-view.c"
								} else {
#line 199 "../src/taquin-view.vala"
									_tmp69_ = y != ((gint) self->priv->y_gap);
#line 800 "taquin-view.c"
								}
#line 199 "../src/taquin-view.vala"
								_tmp68_ = _tmp69_;
#line 804 "taquin-view.c"
							} else {
#line 199 "../src/taquin-view.vala"
								_tmp68_ = FALSE;
#line 808 "taquin-view.c"
							}
#line 199 "../src/taquin-view.vala"
							if (_tmp68_) {
#line 812 "taquin-view.c"
								gboolean _tmp70_ = FALSE;
#line 201 "../src/taquin-view.vala"
								if (self->priv->x_axis) {
#line 201 "../src/taquin-view.vala"
									_tmp70_ = y == ((gint) self->priv->y_gap);
#line 818 "taquin-view.c"
								} else {
#line 201 "../src/taquin-view.vala"
									_tmp70_ = FALSE;
#line 822 "taquin-view.c"
								}
#line 201 "../src/taquin-view.vala"
								if (_tmp70_) {
#line 826 "taquin-view.c"
									gboolean _tmp71_ = FALSE;
									gboolean _tmp72_ = FALSE;
#line 203 "../src/taquin-view.vala"
									if (self->priv->number > 0) {
#line 203 "../src/taquin-view.vala"
										_tmp72_ = x <= (self->priv->x_gap + self->priv->number);
#line 833 "taquin-view.c"
									} else {
#line 203 "../src/taquin-view.vala"
										_tmp72_ = FALSE;
#line 837 "taquin-view.c"
									}
#line 203 "../src/taquin-view.vala"
									if (_tmp72_) {
#line 203 "../src/taquin-view.vala"
										_tmp71_ = x >= ((gint) self->priv->x_gap);
#line 843 "taquin-view.c"
									} else {
#line 203 "../src/taquin-view.vala"
										_tmp71_ = FALSE;
#line 847 "taquin-view.c"
									}
#line 203 "../src/taquin-view.vala"
									if (_tmp71_) {
#line 204 "../src/taquin-view.vala"
										tile_x = tile_x - (self->priv->tile_size - self->priv->animation_offset);
#line 853 "taquin-view.c"
									} else {
										gboolean _tmp73_ = FALSE;
										gboolean _tmp74_ = FALSE;
#line 205 "../src/taquin-view.vala"
										if (self->priv->number < 0) {
#line 205 "../src/taquin-view.vala"
											_tmp74_ = x >= (self->priv->x_gap + self->priv->number);
#line 861 "taquin-view.c"
										} else {
#line 205 "../src/taquin-view.vala"
											_tmp74_ = FALSE;
#line 865 "taquin-view.c"
										}
#line 205 "../src/taquin-view.vala"
										if (_tmp74_) {
#line 205 "../src/taquin-view.vala"
											_tmp73_ = x <= ((gint) self->priv->x_gap);
#line 871 "taquin-view.c"
										} else {
#line 205 "../src/taquin-view.vala"
											_tmp73_ = FALSE;
#line 875 "taquin-view.c"
										}
#line 205 "../src/taquin-view.vala"
										if (_tmp73_) {
#line 206 "../src/taquin-view.vala"
											tile_x = tile_x + (self->priv->tile_size - self->priv->animation_offset);
#line 881 "taquin-view.c"
										}
									}
								} else {
									gboolean _tmp75_ = FALSE;
#line 208 "../src/taquin-view.vala"
									if (!self->priv->x_axis) {
#line 208 "../src/taquin-view.vala"
										_tmp75_ = x == ((gint) self->priv->x_gap);
#line 890 "taquin-view.c"
									} else {
#line 208 "../src/taquin-view.vala"
										_tmp75_ = FALSE;
#line 894 "taquin-view.c"
									}
#line 208 "../src/taquin-view.vala"
									if (_tmp75_) {
#line 898 "taquin-view.c"
										gboolean _tmp76_ = FALSE;
										gboolean _tmp77_ = FALSE;
#line 210 "../src/taquin-view.vala"
										if (self->priv->number > 0) {
#line 210 "../src/taquin-view.vala"
											_tmp77_ = y <= (self->priv->y_gap + self->priv->number);
#line 905 "taquin-view.c"
										} else {
#line 210 "../src/taquin-view.vala"
											_tmp77_ = FALSE;
#line 909 "taquin-view.c"
										}
#line 210 "../src/taquin-view.vala"
										if (_tmp77_) {
#line 210 "../src/taquin-view.vala"
											_tmp76_ = y >= ((gint) self->priv->y_gap);
#line 915 "taquin-view.c"
										} else {
#line 210 "../src/taquin-view.vala"
											_tmp76_ = FALSE;
#line 919 "taquin-view.c"
										}
#line 210 "../src/taquin-view.vala"
										if (_tmp76_) {
#line 211 "../src/taquin-view.vala"
											tile_y = tile_y - (self->priv->tile_size - self->priv->animation_offset);
#line 925 "taquin-view.c"
										} else {
											gboolean _tmp78_ = FALSE;
											gboolean _tmp79_ = FALSE;
#line 212 "../src/taquin-view.vala"
											if (self->priv->number < 0) {
#line 212 "../src/taquin-view.vala"
												_tmp79_ = y >= (self->priv->y_gap + self->priv->number);
#line 933 "taquin-view.c"
											} else {
#line 212 "../src/taquin-view.vala"
												_tmp79_ = FALSE;
#line 937 "taquin-view.c"
											}
#line 212 "../src/taquin-view.vala"
											if (_tmp79_) {
#line 212 "../src/taquin-view.vala"
												_tmp78_ = y <= ((gint) self->priv->y_gap);
#line 943 "taquin-view.c"
											} else {
#line 212 "../src/taquin-view.vala"
												_tmp78_ = FALSE;
#line 947 "taquin-view.c"
											}
#line 212 "../src/taquin-view.vala"
											if (_tmp78_) {
#line 213 "../src/taquin-view.vala"
												tile_y = tile_y + (self->priv->tile_size - self->priv->animation_offset);
#line 953 "taquin-view.c"
											}
										}
									}
								}
							}
#line 217 "../src/taquin-view.vala"
							_tmp80_ = taquin_view_get_game (self);
#line 217 "../src/taquin-view.vala"
							_tmp81_ = _tmp80_;
#line 217 "../src/taquin-view.vala"
							_tmp82_ = taquin_view_get_game (self);
#line 217 "../src/taquin-view.vala"
							_tmp83_ = _tmp82_;
#line 217 "../src/taquin-view.vala"
							_tmp84_ = game_get_size (_tmp83_);
#line 217 "../src/taquin-view.vala"
							_tmp85_ = _tmp84_;
#line 217 "../src/taquin-view.vala"
							texture_x = (game_get_tile_value (_tmp81_, (gint8) x, (gint8) y) % _tmp85_) * self->priv->tile_size;
#line 218 "../src/taquin-view.vala"
							_tmp86_ = taquin_view_get_game (self);
#line 218 "../src/taquin-view.vala"
							_tmp87_ = _tmp86_;
#line 218 "../src/taquin-view.vala"
							_tmp88_ = taquin_view_get_game (self);
#line 218 "../src/taquin-view.vala"
							_tmp89_ = _tmp88_;
#line 218 "../src/taquin-view.vala"
							_tmp90_ = game_get_size (_tmp89_);
#line 218 "../src/taquin-view.vala"
							_tmp91_ = _tmp90_;
#line 218 "../src/taquin-view.vala"
							texture_y = (game_get_tile_value (_tmp87_, (gint8) x, (gint8) y) / _tmp91_) * self->priv->tile_size;
#line 220 "../src/taquin-view.vala"
							cairo_matrix_init_identity (&matrix);
#line 221 "../src/taquin-view.vala"
							cairo_matrix_translate (&matrix, (gdouble) (texture_x - tile_x), (gdouble) (texture_y - tile_y));
#line 222 "../src/taquin-view.vala"
							_tmp92_ = self->priv->tiles_pattern;
#line 222 "../src/taquin-view.vala"
							_tmp93_ = matrix;
#line 222 "../src/taquin-view.vala"
							cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp92_, &_tmp93_);
#line 223 "../src/taquin-view.vala"
							_tmp94_ = self->priv->tiles_pattern;
#line 223 "../src/taquin-view.vala"
							cairo_set_source (cr, (cairo_pattern_t*) _tmp94_);
#line 224 "../src/taquin-view.vala"
							cairo_rectangle (cr, (gdouble) tile_x, (gdouble) tile_y, (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING), (gdouble) (self->priv->tile_size - TAQUIN_VIEW_GRID_SPACING));
#line 225 "../src/taquin-view.vala"
							cairo_fill (cr);
#line 1005 "taquin-view.c"
						}
					}
				}
			}
		}
	}
#line 229 "../src/taquin-view.vala"
	if (self->priv->animate_end) {
#line 1014 "taquin-view.c"
		cairo_matrix_t matrix = {0};
		cairo_pattern_t* _tmp95_;
		cairo_matrix_t _tmp96_;
#line 231 "../src/taquin-view.vala"
		self->priv->animation_end_offset = self->priv->animation_end_offset + 0.01;
#line 232 "../src/taquin-view.vala"
		if (self->priv->animation_end_offset >= ((gdouble) 1)) {
#line 233 "../src/taquin-view.vala"
			self->priv->animation_end_offset = (gdouble) 1;
#line 1024 "taquin-view.c"
		}
#line 234 "../src/taquin-view.vala"
		cairo_matrix_init_identity (&matrix);
#line 235 "../src/taquin-view.vala"
		_tmp95_ = self->priv->tiles_pattern;
#line 235 "../src/taquin-view.vala"
		_tmp96_ = matrix;
#line 235 "../src/taquin-view.vala"
		cairo_pattern_set_matrix ((cairo_pattern_t*) _tmp95_, &_tmp96_);
#line 236 "../src/taquin-view.vala"
		cairo_paint_with_alpha (cr, self->priv->animation_end_offset);
#line 237 "../src/taquin-view.vala"
		if (self->priv->animation_end_offset != ((gdouble) 1)) {
#line 238 "../src/taquin-view.vala"
			gtk_widget_queue_draw ((GtkWidget*) self);
#line 1040 "taquin-view.c"
		}
	}
#line 240 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 242 "../src/taquin-view.vala"
	if (self->priv->animate) {
#line 244 "../src/taquin-view.vala"
		self->priv->animation_offset = self->priv->animation_offset + 8;
#line 245 "../src/taquin-view.vala"
		if (self->priv->x_axis) {
#line 1051 "taquin-view.c"
			gint _tmp97_;
			gint _tmp98_;
			gint _tmp99_;
			gint _tmp100_;
#line 246 "../src/taquin-view.vala"
			_tmp97_ = taquin_view_get_x_offset (self);
#line 246 "../src/taquin-view.vala"
			_tmp98_ = _tmp97_;
#line 246 "../src/taquin-view.vala"
			_tmp99_ = taquin_view_get_y_offset (self);
#line 246 "../src/taquin-view.vala"
			_tmp100_ = _tmp99_;
#line 246 "../src/taquin-view.vala"
			gtk_widget_queue_draw_area ((GtkWidget*) self, (_tmp98_ + self->priv->grid_border_main) + (self->priv->tile_size * MIN ((gint) self->priv->x_gap, self->priv->x_gap + self->priv->number)), (_tmp100_ + self->priv->grid_border_main) + (self->priv->tile_size * self->priv->y_gap), self->priv->tile_size * (abs (self->priv->number) + 1), self->priv->tile_size);
#line 1066 "taquin-view.c"
		} else {
			gint _tmp101_;
			gint _tmp102_;
			gint _tmp103_;
			gint _tmp104_;
#line 251 "../src/taquin-view.vala"
			_tmp101_ = taquin_view_get_x_offset (self);
#line 251 "../src/taquin-view.vala"
			_tmp102_ = _tmp101_;
#line 251 "../src/taquin-view.vala"
			_tmp103_ = taquin_view_get_y_offset (self);
#line 251 "../src/taquin-view.vala"
			_tmp104_ = _tmp103_;
#line 251 "../src/taquin-view.vala"
			gtk_widget_queue_draw_area ((GtkWidget*) self, (_tmp102_ + self->priv->grid_border_main) + (self->priv->tile_size * self->priv->x_gap), (_tmp104_ + self->priv->grid_border_main) + (self->priv->tile_size * MIN ((gint) self->priv->y_gap, self->priv->y_gap + self->priv->number)), self->priv->tile_size, self->priv->tile_size * (abs (self->priv->number) + 1));
#line 1082 "taquin-view.c"
		}
#line 255 "../src/taquin-view.vala"
		if (self->priv->animation_offset > self->priv->tile_size) {
#line 256 "../src/taquin-view.vala"
			self->priv->animate = FALSE;
#line 1088 "taquin-view.c"
		}
	}
#line 259 "../src/taquin-view.vala"
	result = FALSE;
#line 259 "../src/taquin-view.vala"
	return result;
#line 1095 "taquin-view.c"
}

static inline void
_taquin_view_load_image (cairo_t* c,
                         const gchar* theme,
                         gint* board_size)
{
	GError* _inner_error0_ = NULL;
#line 262 "../src/taquin-view.vala"
	g_return_if_fail (c != NULL);
#line 262 "../src/taquin-view.vala"
	g_return_if_fail (theme != NULL);
#line 1108 "taquin-view.c"
	{
		GdkPixbuf* p = NULL;
		GdkPixbuf* _tmp0_;
#line 282 "../src/taquin-view.vala"
		_tmp0_ = gdk_pixbuf_new_from_file_at_scale (theme, *board_size, *board_size, FALSE, &_inner_error0_);
#line 282 "../src/taquin-view.vala"
		p = _tmp0_;
#line 282 "../src/taquin-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1118 "taquin-view.c"
			goto __catch4_g_error;
		}
#line 283 "../src/taquin-view.vala"
		gdk_cairo_set_source_pixbuf (c, p, (gdouble) 0, (gdouble) 0);
#line 284 "../src/taquin-view.vala"
		cairo_paint (c);
#line 280 "../src/taquin-view.vala"
		_g_object_unref0 (p);
#line 1127 "taquin-view.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 280 "../src/taquin-view.vala"
		e = _inner_error0_;
#line 280 "../src/taquin-view.vala"
		_inner_error0_ = NULL;
#line 288 "../src/taquin-view.vala"
		_tmp1_ = e;
#line 288 "../src/taquin-view.vala"
		_tmp2_ = _tmp1_->message;
#line 288 "../src/taquin-view.vala"
		g_warning ("taquin-view.vala:288: Failed to load theme %s: %s\n" \
"\n" \
"If you were trying to launch an unusual size, retry, it may work. But " \
"it probably implies that you have not an image adapted to the requeste" \
"d size in the current theme. If that's not the case, file a bug please" \
".\n", theme, _tmp2_);
#line 280 "../src/taquin-view.vala"
		_g_error_free0 (e);
#line 1147 "taquin-view.c"
	}
	__finally4:
#line 280 "../src/taquin-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "../src/taquin-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 280 "../src/taquin-view.vala"
		g_clear_error (&_inner_error0_);
#line 280 "../src/taquin-view.vala"
		return;
#line 1158 "taquin-view.c"
	}
}

static inline void
_taquin_view_draw_board (cairo_t* cr,
                         gint* grid_border_main,
                         gint* board_size,
                         gint* grid_border_thin)
{
	gdouble half_grid_border_main_first_side = 0.0;
	gdouble board_size_plus_two_half_borders = 0.0;
	gdouble half_grid_border_main_other_side = 0.0;
	gdouble half_grid_borders_diff = 0.0;
#line 294 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 299 "../src/taquin-view.vala"
	half_grid_border_main_first_side = (*grid_border_main) / 2.0;
#line 300 "../src/taquin-view.vala"
	board_size_plus_two_half_borders = (gdouble) ((*board_size) + (*grid_border_main));
#line 301 "../src/taquin-view.vala"
	half_grid_border_main_other_side = board_size_plus_two_half_borders + half_grid_border_main_first_side;
#line 302 "../src/taquin-view.vala"
	half_grid_borders_diff = ((*grid_border_main) - (*grid_border_thin)) / 2.0;
#line 305 "../src/taquin-view.vala"
	cairo_set_source_rgb (cr, 0.8, 0.8, 0.8);
#line 306 "../src/taquin-view.vala"
	cairo_rectangle (cr, half_grid_border_main_first_side, half_grid_border_main_first_side, board_size_plus_two_half_borders, board_size_plus_two_half_borders);
#line 308 "../src/taquin-view.vala"
	cairo_fill_preserve (cr);
#line 309 "../src/taquin-view.vala"
	cairo_set_source_rgb (cr, 0.3, 0.3, 0.3);
#line 310 "../src/taquin-view.vala"
	cairo_set_line_width (cr, (gdouble) (*grid_border_main));
#line 311 "../src/taquin-view.vala"
	cairo_stroke (cr);
#line 314 "../src/taquin-view.vala"
	cairo_set_source_rgb (cr, 0.1, 0.1, 0.1);
#line 315 "../src/taquin-view.vala"
	cairo_set_line_width (cr, (gdouble) (*grid_border_thin));
#line 316 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_first_side, half_grid_border_main_first_side, half_grid_borders_diff, G_PI, TAQUIN_VIEW_three_half_pi);
#line 317 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_other_side, half_grid_border_main_first_side, half_grid_borders_diff, TAQUIN_VIEW_three_half_pi, 0.0);
#line 318 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_other_side, half_grid_border_main_other_side, half_grid_borders_diff, 0.0, TAQUIN_VIEW_half_pi);
#line 319 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_first_side, half_grid_border_main_other_side, half_grid_borders_diff, TAQUIN_VIEW_half_pi, G_PI);
#line 320 "../src/taquin-view.vala"
	cairo_arc (cr, half_grid_border_main_first_side, half_grid_border_main_first_side, half_grid_borders_diff, G_PI, TAQUIN_VIEW_three_half_pi);
#line 321 "../src/taquin-view.vala"
	cairo_stroke (cr);
#line 1210 "taquin-view.c"
}

static inline void
taquin_view_draw_movable_lights (TaquinView* self,
                                 cairo_t* cr)
{
#line 324 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 326 "../src/taquin-view.vala"
	_taquin_view_draw_movable_lights (cr, &self->priv->animation_end_offset, &self->priv->grid_border_main, &self->priv->tile_size, &self->priv->x_arrow, &self->priv->grid_border_thin, &self->priv->board_size, &self->priv->y_arrow);
#line 1223 "taquin-view.c"
}

static inline void
_taquin_view_draw_movable_lights (cairo_t* cr,
                                  gdouble* animation_end_offset,
                                  gint* grid_border_main,
                                  gint* tile_size,
                                  gint8* x_arrow,
                                  gint* grid_border_thin,
                                  gint* board_size,
                                  gint8* y_arrow)
{
	gdouble half_grid_borders_sum = 0.0;
	gint board_size_plus_borders_diff = 0;
#line 328 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 337 "../src/taquin-view.vala"
	half_grid_borders_sum = ((*grid_border_main) + (*grid_border_thin)) / 2.0;
#line 338 "../src/taquin-view.vala"
	board_size_plus_borders_diff = ((*board_size) + (*grid_border_main)) - (*grid_border_thin);
#line 340 "../src/taquin-view.vala"
	cairo_save (cr);
#line 341 "../src/taquin-view.vala"
	cairo_set_source_rgba (cr, 0.7, 0.7, 0.7, 0.3 - (0.3 * (*animation_end_offset)));
#line 343 "../src/taquin-view.vala"
	cairo_save (cr);
#line 344 "../src/taquin-view.vala"
	cairo_translate (cr, (*grid_border_main) + ((*tile_size) * ((*x_arrow) + 0.5)), half_grid_borders_sum);
#line 345 "../src/taquin-view.vala"
	taquin_view_draw_light (cr, TRUE, tile_size, grid_border_main);
#line 346 "../src/taquin-view.vala"
	cairo_translate (cr, (gdouble) 0, (gdouble) board_size_plus_borders_diff);
#line 347 "../src/taquin-view.vala"
	taquin_view_draw_light (cr, TRUE, tile_size, grid_border_main);
#line 348 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 349 "../src/taquin-view.vala"
	cairo_fill (cr);
#line 351 "../src/taquin-view.vala"
	cairo_save (cr);
#line 352 "../src/taquin-view.vala"
	cairo_translate (cr, half_grid_borders_sum, (*grid_border_main) + ((*tile_size) * ((*y_arrow) + 0.5)));
#line 353 "../src/taquin-view.vala"
	taquin_view_draw_light (cr, FALSE, tile_size, grid_border_main);
#line 354 "../src/taquin-view.vala"
	cairo_translate (cr, (gdouble) board_size_plus_borders_diff, (gdouble) 0);
#line 355 "../src/taquin-view.vala"
	taquin_view_draw_light (cr, FALSE, tile_size, grid_border_main);
#line 356 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 357 "../src/taquin-view.vala"
	cairo_fill (cr);
#line 358 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 1278 "taquin-view.c"
}

static void
taquin_view_draw_light (cairo_t* cr,
                        gboolean horizontal,
                        gint* tile_size,
                        gint* grid_border_main)
{
	gdouble size = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
#line 360 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 362 "../src/taquin-view.vala"
	cairo_save (cr);
#line 363 "../src/taquin-view.vala"
	size = (0.3 * (*tile_size)) / (*grid_border_main);
#line 364 "../src/taquin-view.vala"
	if (horizontal) {
#line 364 "../src/taquin-view.vala"
		_tmp0_ = size;
#line 1300 "taquin-view.c"
	} else {
#line 364 "../src/taquin-view.vala"
		_tmp0_ = 0.3;
#line 1304 "taquin-view.c"
	}
#line 364 "../src/taquin-view.vala"
	if (horizontal) {
#line 364 "../src/taquin-view.vala"
		_tmp1_ = 0.3;
#line 1310 "taquin-view.c"
	} else {
#line 364 "../src/taquin-view.vala"
		_tmp1_ = size;
#line 1314 "taquin-view.c"
	}
#line 364 "../src/taquin-view.vala"
	cairo_scale (cr, _tmp0_, _tmp1_);
#line 365 "../src/taquin-view.vala"
	cairo_arc (cr, 0.0, 0.0, (gdouble) (*grid_border_main), 0.0, 2.0 * G_PI);
#line 366 "../src/taquin-view.vala"
	cairo_restore (cr);
#line 1322 "taquin-view.c"
}

static inline void
taquin_view_draw_fixed_arrows (TaquinView* self,
                               cairo_t* cr)
{
	Game* _tmp0_;
	Game* _tmp1_;
	gint8 _tmp2_;
	gint8 _tmp3_;
#line 369 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 369 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 371 "../src/taquin-view.vala"
	_tmp0_ = taquin_view_get_game (self);
#line 371 "../src/taquin-view.vala"
	_tmp1_ = _tmp0_;
#line 371 "../src/taquin-view.vala"
	_tmp2_ = game_get_size (_tmp1_);
#line 371 "../src/taquin-view.vala"
	_tmp3_ = _tmp2_;
#line 371 "../src/taquin-view.vala"
	_taquin_view_draw_fixed_arrows (cr, (gint) _tmp3_, &self->priv->grid_border_main, &self->priv->tile_size, &self->priv->grid_border_thin, &self->priv->board_size);
#line 1347 "taquin-view.c"
}

static inline void
_taquin_view_draw_fixed_arrows (cairo_t* cr,
                                gint game_size,
                                gint* grid_border_main,
                                gint* tile_size,
                                gint* grid_border_thin,
                                gint* board_size)
{
#line 373 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 1360 "taquin-view.c"
	{
		gint i = 0;
#line 379 "../src/taquin-view.vala"
		i = 0;
#line 1365 "taquin-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 379 "../src/taquin-view.vala"
			_tmp0_ = TRUE;
#line 379 "../src/taquin-view.vala"
			while (TRUE) {
#line 379 "../src/taquin-view.vala"
				if (!_tmp0_) {
#line 1374 "taquin-view.c"
					gint _tmp1_;
#line 379 "../src/taquin-view.vala"
					_tmp1_ = i;
#line 379 "../src/taquin-view.vala"
					i = _tmp1_ + 1;
#line 1380 "taquin-view.c"
				}
#line 379 "../src/taquin-view.vala"
				_tmp0_ = FALSE;
#line 379 "../src/taquin-view.vala"
				if (!(i < game_size)) {
#line 379 "../src/taquin-view.vala"
					break;
#line 1388 "taquin-view.c"
				}
#line 381 "../src/taquin-view.vala"
				taquin_view_draw_vertical_arrow (cr, FALSE, i, grid_border_main, tile_size, grid_border_thin, board_size);
#line 382 "../src/taquin-view.vala"
				taquin_view_draw_horizontal_arrow (cr, FALSE, i, grid_border_main, tile_size, grid_border_thin, board_size);
#line 1394 "taquin-view.c"
			}
		}
	}
}

static inline void
taquin_view_draw_movable_arrows (TaquinView* self,
                                 cairo_t* cr)
{
#line 386 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 388 "../src/taquin-view.vala"
	_taquin_view_draw_movable_arrows (cr, &self->priv->x_arrow, &self->priv->y_arrow, &self->priv->grid_border_main, &self->priv->tile_size, &self->priv->grid_border_thin, &self->priv->board_size);
#line 1410 "taquin-view.c"
}

static inline void
_taquin_view_draw_movable_arrows (cairo_t* cr,
                                  gint8* x_arrow,
                                  gint8* y_arrow,
                                  gint* grid_border_main,
                                  gint* tile_size,
                                  gint* grid_border_thin,
                                  gint* board_size)
{
#line 390 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 398 "../src/taquin-view.vala"
	taquin_view_draw_vertical_arrow (cr, TRUE, (gint) (*x_arrow), grid_border_main, tile_size, grid_border_thin, board_size);
#line 399 "../src/taquin-view.vala"
	taquin_view_draw_horizontal_arrow (cr, TRUE, (gint) (*y_arrow), grid_border_main, tile_size, grid_border_thin, board_size);
#line 1428 "taquin-view.c"
}

static void
taquin_view_draw_horizontal_arrow (cairo_t* cr,
                                   gboolean inside,
                                   gint number,
                                   gint* grid_border_main,
                                   gint* tile_size,
                                   gint* grid_border_thin,
                                   gint* board_size)
{
	gdouble x1 = 0.0;
	gdouble x2 = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 402 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 408 "../src/taquin-view.vala"
	x1 = (((*grid_border_main) * 1.0) / 3) + (((*grid_border_thin) * 2.0) / 3);
#line 409 "../src/taquin-view.vala"
	x2 = (((*grid_border_main) * 2.0) / 3) + (((*grid_border_thin) * 1.0) / 3);
#line 410 "../src/taquin-view.vala"
	if (inside) {
#line 410 "../src/taquin-view.vala"
		_tmp0_ = x1;
#line 1458 "taquin-view.c"
	} else {
#line 410 "../src/taquin-view.vala"
		_tmp0_ = x2;
#line 1462 "taquin-view.c"
	}
#line 410 "../src/taquin-view.vala"
	cairo_move_to (cr, _tmp0_, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 3))));
#line 411 "../src/taquin-view.vala"
	if (inside) {
#line 411 "../src/taquin-view.vala"
		_tmp1_ = x2;
#line 1470 "taquin-view.c"
	} else {
#line 411 "../src/taquin-view.vala"
		_tmp1_ = x1;
#line 1474 "taquin-view.c"
	}
#line 411 "../src/taquin-view.vala"
	cairo_line_to (cr, _tmp1_, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 2))));
#line 412 "../src/taquin-view.vala"
	if (inside) {
#line 412 "../src/taquin-view.vala"
		_tmp2_ = x1;
#line 1482 "taquin-view.c"
	} else {
#line 412 "../src/taquin-view.vala"
		_tmp2_ = x2;
#line 1486 "taquin-view.c"
	}
#line 412 "../src/taquin-view.vala"
	cairo_line_to (cr, _tmp2_, (*grid_border_main) + ((*tile_size) * (number + (2.0 / 3))));
#line 413 "../src/taquin-view.vala"
	x1 = ((*board_size) + (((*grid_border_main) * 5.0) / 3)) - (((*grid_border_thin) * 2.0) / 3);
#line 414 "../src/taquin-view.vala"
	x2 = ((*board_size) + (((*grid_border_main) * 4.0) / 3)) - (((*grid_border_thin) * 1.0) / 3);
#line 415 "../src/taquin-view.vala"
	if (inside) {
#line 415 "../src/taquin-view.vala"
		_tmp3_ = x1;
#line 1498 "taquin-view.c"
	} else {
#line 415 "../src/taquin-view.vala"
		_tmp3_ = x2;
#line 1502 "taquin-view.c"
	}
#line 415 "../src/taquin-view.vala"
	cairo_move_to (cr, _tmp3_, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 3))));
#line 416 "../src/taquin-view.vala"
	if (inside) {
#line 416 "../src/taquin-view.vala"
		_tmp4_ = x2;
#line 1510 "taquin-view.c"
	} else {
#line 416 "../src/taquin-view.vala"
		_tmp4_ = x1;
#line 1514 "taquin-view.c"
	}
#line 416 "../src/taquin-view.vala"
	cairo_line_to (cr, _tmp4_, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 2))));
#line 417 "../src/taquin-view.vala"
	if (inside) {
#line 417 "../src/taquin-view.vala"
		_tmp5_ = x1;
#line 1522 "taquin-view.c"
	} else {
#line 417 "../src/taquin-view.vala"
		_tmp5_ = x2;
#line 1526 "taquin-view.c"
	}
#line 417 "../src/taquin-view.vala"
	cairo_line_to (cr, _tmp5_, (*grid_border_main) + ((*tile_size) * (number + (2.0 / 3))));
#line 1530 "taquin-view.c"
}

static void
taquin_view_draw_vertical_arrow (cairo_t* cr,
                                 gboolean inside,
                                 gint number,
                                 gint* grid_border_main,
                                 gint* tile_size,
                                 gint* grid_border_thin,
                                 gint* board_size)
{
	gdouble y1 = 0.0;
	gdouble y2 = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
#line 420 "../src/taquin-view.vala"
	g_return_if_fail (cr != NULL);
#line 426 "../src/taquin-view.vala"
	y1 = (((*grid_border_main) * 1.0) / 3) + (((*grid_border_thin) * 2.0) / 3);
#line 427 "../src/taquin-view.vala"
	y2 = (((*grid_border_main) * 2.0) / 3) + (((*grid_border_thin) * 1.0) / 3);
#line 428 "../src/taquin-view.vala"
	if (inside) {
#line 428 "../src/taquin-view.vala"
		_tmp0_ = y1;
#line 1560 "taquin-view.c"
	} else {
#line 428 "../src/taquin-view.vala"
		_tmp0_ = y2;
#line 1564 "taquin-view.c"
	}
#line 428 "../src/taquin-view.vala"
	cairo_move_to (cr, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 3))), _tmp0_);
#line 429 "../src/taquin-view.vala"
	if (inside) {
#line 429 "../src/taquin-view.vala"
		_tmp1_ = y2;
#line 1572 "taquin-view.c"
	} else {
#line 429 "../src/taquin-view.vala"
		_tmp1_ = y1;
#line 1576 "taquin-view.c"
	}
#line 429 "../src/taquin-view.vala"
	cairo_line_to (cr, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 2))), _tmp1_);
#line 430 "../src/taquin-view.vala"
	if (inside) {
#line 430 "../src/taquin-view.vala"
		_tmp2_ = y1;
#line 1584 "taquin-view.c"
	} else {
#line 430 "../src/taquin-view.vala"
		_tmp2_ = y2;
#line 1588 "taquin-view.c"
	}
#line 430 "../src/taquin-view.vala"
	cairo_line_to (cr, (*grid_border_main) + ((*tile_size) * (number + (2.0 / 3))), _tmp2_);
#line 431 "../src/taquin-view.vala"
	y1 = ((*board_size) + (((*grid_border_main) * 5.0) / 3)) - (((*grid_border_thin) * 2.0) / 3);
#line 432 "../src/taquin-view.vala"
	y2 = ((*board_size) + (((*grid_border_main) * 4.0) / 3)) - (((*grid_border_thin) * 1.0) / 3);
#line 433 "../src/taquin-view.vala"
	if (inside) {
#line 433 "../src/taquin-view.vala"
		_tmp3_ = y1;
#line 1600 "taquin-view.c"
	} else {
#line 433 "../src/taquin-view.vala"
		_tmp3_ = y2;
#line 1604 "taquin-view.c"
	}
#line 433 "../src/taquin-view.vala"
	cairo_move_to (cr, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 3))), _tmp3_);
#line 434 "../src/taquin-view.vala"
	if (inside) {
#line 434 "../src/taquin-view.vala"
		_tmp4_ = y2;
#line 1612 "taquin-view.c"
	} else {
#line 434 "../src/taquin-view.vala"
		_tmp4_ = y1;
#line 1616 "taquin-view.c"
	}
#line 434 "../src/taquin-view.vala"
	cairo_line_to (cr, (*grid_border_main) + ((*tile_size) * (number + (1.0 / 2))), _tmp4_);
#line 435 "../src/taquin-view.vala"
	if (inside) {
#line 435 "../src/taquin-view.vala"
		_tmp5_ = y1;
#line 1624 "taquin-view.c"
	} else {
#line 435 "../src/taquin-view.vala"
		_tmp5_ = y2;
#line 1628 "taquin-view.c"
	}
#line 435 "../src/taquin-view.vala"
	cairo_line_to (cr, (*grid_border_main) + ((*tile_size) * (number + (2.0 / 3))), _tmp5_);
#line 1632 "taquin-view.c"
}

static void
taquin_view_move_cb (TaquinView* self,
                     gboolean x_axis,
                     gint8 number,
                     gint8 x_gap,
                     gint8 y_gap,
                     guint moves_count,
                     gboolean disable_animation)
{
	Game* _tmp0_;
	Game* _tmp1_;
	GameType _tmp2_;
	GameType _tmp3_;
#line 438 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 440 "../src/taquin-view.vala"
	self->priv->x_axis = x_axis;
#line 441 "../src/taquin-view.vala"
	self->priv->number = (gint) number;
#line 442 "../src/taquin-view.vala"
	self->priv->x_gap = x_gap;
#line 443 "../src/taquin-view.vala"
	self->priv->y_gap = y_gap;
#line 445 "../src/taquin-view.vala"
	_tmp0_ = taquin_view_get_game (self);
#line 445 "../src/taquin-view.vala"
	_tmp1_ = _tmp0_;
#line 445 "../src/taquin-view.vala"
	_tmp2_ = game_get_game_type (_tmp1_);
#line 445 "../src/taquin-view.vala"
	_tmp3_ = _tmp2_;
#line 445 "../src/taquin-view.vala"
	if (_tmp3_ == GAME_TYPE_FIFTEEN) {
#line 447 "../src/taquin-view.vala"
		self->priv->x_arrow = x_gap;
#line 448 "../src/taquin-view.vala"
		self->priv->y_arrow = y_gap;
#line 1672 "taquin-view.c"
	}
#line 450 "../src/taquin-view.vala"
	if (disable_animation) {
#line 452 "../src/taquin-view.vala"
		self->priv->finished = FALSE;
#line 453 "../src/taquin-view.vala"
		self->priv->animation_end_offset = (gdouble) 0;
#line 454 "../src/taquin-view.vala"
		self->priv->animate_end = FALSE;
#line 1682 "taquin-view.c"
	} else {
#line 458 "../src/taquin-view.vala"
		self->priv->animation_offset = 0;
#line 459 "../src/taquin-view.vala"
		self->priv->animate = TRUE;
#line 1688 "taquin-view.c"
	}
#line 461 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1692 "taquin-view.c"
}

static gboolean
__lambda13_ (TaquinView* self)
{
	gboolean result = FALSE;
#line 469 "../src/taquin-view.vala"
	self->priv->animation_end_offset = (gdouble) 0;
#line 470 "../src/taquin-view.vala"
	self->priv->animate_end = TRUE;
#line 471 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 473 "../src/taquin-view.vala"
	result = FALSE;
#line 473 "../src/taquin-view.vala"
	return result;
#line 1709 "taquin-view.c"
}

static gboolean
___lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda13_ ((TaquinView*) self);
#line 467 "../src/taquin-view.vala"
	return result;
#line 1719 "taquin-view.c"
}

static void
taquin_view_complete_cb (TaquinView* self)
{
#line 464 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 466 "../src/taquin-view.vala"
	self->priv->finished = TRUE;
#line 467 "../src/taquin-view.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ___lambda13__gsource_func, g_object_ref (self), g_object_unref);
#line 1731 "taquin-view.c"
}

static gboolean
taquin_view_real_button_press_event (GtkWidget* base,
                                     GdkEventButton* event)
{
	TaquinView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 477 "../src/taquin-view.vala"
	self = (TaquinView*) base;
#line 477 "../src/taquin-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 479 "../src/taquin-view.vala"
	if (self->priv->finished) {
#line 479 "../src/taquin-view.vala"
		_tmp1_ = TRUE;
#line 1751 "taquin-view.c"
	} else {
#line 479 "../src/taquin-view.vala"
		_tmp1_ = self->priv->animate;
#line 1755 "taquin-view.c"
	}
#line 479 "../src/taquin-view.vala"
	if (_tmp1_) {
#line 479 "../src/taquin-view.vala"
		_tmp0_ = TRUE;
#line 1761 "taquin-view.c"
	} else {
#line 479 "../src/taquin-view.vala"
		_tmp0_ = self->priv->animate_end;
#line 1765 "taquin-view.c"
	}
#line 479 "../src/taquin-view.vala"
	if (_tmp0_) {
#line 480 "../src/taquin-view.vala"
		result = TRUE;
#line 480 "../src/taquin-view.vala"
		return result;
#line 1773 "taquin-view.c"
	}
#line 481 "../src/taquin-view.vala"
	if (event->button == ((guint) GDK_BUTTON_PRIMARY)) {
#line 481 "../src/taquin-view.vala"
		_tmp2_ = TRUE;
#line 1779 "taquin-view.c"
	} else {
#line 481 "../src/taquin-view.vala"
		_tmp2_ = event->button == ((guint) GDK_BUTTON_SECONDARY);
#line 1783 "taquin-view.c"
	}
#line 481 "../src/taquin-view.vala"
	if (_tmp2_) {
#line 1787 "taquin-view.c"
		Game* _tmp3_;
		Game* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 483 "../src/taquin-view.vala"
		self->priv->draw_lights = FALSE;
#line 484 "../src/taquin-view.vala"
		_tmp3_ = taquin_view_get_game (self);
#line 484 "../src/taquin-view.vala"
		_tmp4_ = _tmp3_;
#line 484 "../src/taquin-view.vala"
		_tmp5_ = taquin_view_get_x_offset (self);
#line 484 "../src/taquin-view.vala"
		_tmp6_ = _tmp5_;
#line 484 "../src/taquin-view.vala"
		_tmp7_ = taquin_view_get_y_offset (self);
#line 484 "../src/taquin-view.vala"
		_tmp8_ = _tmp7_;
#line 484 "../src/taquin-view.vala"
		game_request_move (_tmp4_, (gint8) ((((gint) (((event->x - _tmp6_) - self->priv->grid_border_main) + self->priv->tile_size)) / self->priv->tile_size) - 1), (gint8) ((((gint) (((event->y - _tmp8_) - self->priv->grid_border_main) + self->priv->tile_size)) / self->priv->tile_size) - 1), FALSE);
#line 1810 "taquin-view.c"
	}
#line 488 "../src/taquin-view.vala"
	result = TRUE;
#line 488 "../src/taquin-view.vala"
	return result;
#line 1816 "taquin-view.c"
}

static gboolean
taquin_view_real_key_press_event (GtkWidget* base,
                                  GdkEventKey* event)
{
	TaquinView * self;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* k_name = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Game* _tmp4_;
	Game* _tmp5_;
	GameType _tmp6_;
	GameType _tmp7_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	const gchar* _tmp33_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	GQuark _tmp41_ = 0U;
#line 512 "../src/taquin-view.vala"
	static GQuark _tmp40_label0 = 0;
#line 512 "../src/taquin-view.vala"
	static GQuark _tmp40_label1 = 0;
#line 512 "../src/taquin-view.vala"
	static GQuark _tmp40_label2 = 0;
#line 512 "../src/taquin-view.vala"
	static GQuark _tmp40_label3 = 0;
#line 491 "../src/taquin-view.vala"
	self = (TaquinView*) base;
#line 491 "../src/taquin-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 493 "../src/taquin-view.vala"
	if (self->priv->finished) {
#line 494 "../src/taquin-view.vala"
		result = FALSE;
#line 494 "../src/taquin-view.vala"
		return result;
#line 1858 "taquin-view.c"
	}
#line 495 "../src/taquin-view.vala"
	_tmp1_ = gdk_keyval_name (event->keyval);
#line 495 "../src/taquin-view.vala"
	_tmp0_ = _tmp1_;
#line 495 "../src/taquin-view.vala"
	if (_tmp0_ == NULL) {
#line 495 "../src/taquin-view.vala"
		_tmp0_ = "";
#line 1868 "taquin-view.c"
	}
#line 495 "../src/taquin-view.vala"
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
#line 495 "../src/taquin-view.vala"
	k_name = _tmp2_;
#line 497 "../src/taquin-view.vala"
	_tmp4_ = taquin_view_get_game (self);
#line 497 "../src/taquin-view.vala"
	_tmp5_ = _tmp4_;
#line 497 "../src/taquin-view.vala"
	_tmp6_ = game_get_game_type (_tmp5_);
#line 497 "../src/taquin-view.vala"
	_tmp7_ = _tmp6_;
#line 497 "../src/taquin-view.vala"
	if (_tmp7_ == GAME_TYPE_SIXTEEN) {
#line 1884 "taquin-view.c"
		gboolean _tmp8_ = FALSE;
		GdkModifierType _tmp9_;
#line 497 "../src/taquin-view.vala"
		_tmp9_ = event->state;
#line 497 "../src/taquin-view.vala"
		if ((_tmp9_ & GDK_SHIFT_MASK) > 0) {
#line 497 "../src/taquin-view.vala"
			_tmp8_ = TRUE;
#line 1893 "taquin-view.c"
		} else {
			GdkModifierType _tmp10_;
#line 497 "../src/taquin-view.vala"
			_tmp10_ = event->state;
#line 497 "../src/taquin-view.vala"
			_tmp8_ = (_tmp10_ & GDK_CONTROL_MASK) > 0;
#line 1900 "taquin-view.c"
		}
#line 497 "../src/taquin-view.vala"
		_tmp3_ = _tmp8_;
#line 1904 "taquin-view.c"
	} else {
#line 497 "../src/taquin-view.vala"
		_tmp3_ = FALSE;
#line 1908 "taquin-view.c"
	}
#line 497 "../src/taquin-view.vala"
	if (_tmp3_) {
#line 1912 "taquin-view.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		GQuark _tmp14_ = 0U;
#line 499 "../src/taquin-view.vala"
		static GQuark _tmp13_label0 = 0;
#line 499 "../src/taquin-view.vala"
		static GQuark _tmp13_label1 = 0;
#line 499 "../src/taquin-view.vala"
		static GQuark _tmp13_label2 = 0;
#line 499 "../src/taquin-view.vala"
		static GQuark _tmp13_label3 = 0;
#line 499 "../src/taquin-view.vala"
		_tmp11_ = k_name;
#line 499 "../src/taquin-view.vala"
		_tmp12_ = _tmp11_;
#line 499 "../src/taquin-view.vala"
		_tmp14_ = (NULL == _tmp12_) ? 0 : g_quark_from_string (_tmp12_);
#line 499 "../src/taquin-view.vala"
		if (_tmp14_ == ((0 != _tmp13_label0) ? _tmp13_label0 : (_tmp13_label0 = g_quark_from_static_string ("Left")))) {
#line 499 "../src/taquin-view.vala"
			switch (0) {
#line 1934 "taquin-view.c"
				default:
				{
					Game* _tmp15_;
					Game* _tmp16_;
#line 500 "../src/taquin-view.vala"
					_tmp15_ = taquin_view_get_game (self);
#line 500 "../src/taquin-view.vala"
					_tmp16_ = _tmp15_;
#line 500 "../src/taquin-view.vala"
					game_request_move (_tmp16_, (gint8) -1, self->priv->y_arrow, TRUE);
#line 500 "../src/taquin-view.vala"
					break;
#line 1947 "taquin-view.c"
				}
			}
		} else if (_tmp14_ == ((0 != _tmp13_label1) ? _tmp13_label1 : (_tmp13_label1 = g_quark_from_static_string ("Right")))) {
#line 499 "../src/taquin-view.vala"
			switch (0) {
#line 1953 "taquin-view.c"
				default:
				{
					Game* _tmp17_;
					Game* _tmp18_;
					Game* _tmp19_;
					Game* _tmp20_;
					gint8 _tmp21_;
					gint8 _tmp22_;
#line 501 "../src/taquin-view.vala"
					_tmp17_ = taquin_view_get_game (self);
#line 501 "../src/taquin-view.vala"
					_tmp18_ = _tmp17_;
#line 501 "../src/taquin-view.vala"
					_tmp19_ = taquin_view_get_game (self);
#line 501 "../src/taquin-view.vala"
					_tmp20_ = _tmp19_;
#line 501 "../src/taquin-view.vala"
					_tmp21_ = game_get_size (_tmp20_);
#line 501 "../src/taquin-view.vala"
					_tmp22_ = _tmp21_;
#line 501 "../src/taquin-view.vala"
					game_request_move (_tmp18_, _tmp22_, self->priv->y_arrow, TRUE);
#line 501 "../src/taquin-view.vala"
					break;
#line 1978 "taquin-view.c"
				}
			}
		} else if (_tmp14_ == ((0 != _tmp13_label2) ? _tmp13_label2 : (_tmp13_label2 = g_quark_from_static_string ("Up")))) {
#line 499 "../src/taquin-view.vala"
			switch (0) {
#line 1984 "taquin-view.c"
				default:
				{
					Game* _tmp23_;
					Game* _tmp24_;
#line 502 "../src/taquin-view.vala"
					_tmp23_ = taquin_view_get_game (self);
#line 502 "../src/taquin-view.vala"
					_tmp24_ = _tmp23_;
#line 502 "../src/taquin-view.vala"
					game_request_move (_tmp24_, self->priv->x_arrow, (gint8) -1, TRUE);
#line 502 "../src/taquin-view.vala"
					break;
#line 1997 "taquin-view.c"
				}
			}
		} else if (_tmp14_ == ((0 != _tmp13_label3) ? _tmp13_label3 : (_tmp13_label3 = g_quark_from_static_string ("Down")))) {
#line 499 "../src/taquin-view.vala"
			switch (0) {
#line 2003 "taquin-view.c"
				default:
				{
					Game* _tmp25_;
					Game* _tmp26_;
					Game* _tmp27_;
					Game* _tmp28_;
					gint8 _tmp29_;
					gint8 _tmp30_;
#line 503 "../src/taquin-view.vala"
					_tmp25_ = taquin_view_get_game (self);
#line 503 "../src/taquin-view.vala"
					_tmp26_ = _tmp25_;
#line 503 "../src/taquin-view.vala"
					_tmp27_ = taquin_view_get_game (self);
#line 503 "../src/taquin-view.vala"
					_tmp28_ = _tmp27_;
#line 503 "../src/taquin-view.vala"
					_tmp29_ = game_get_size (_tmp28_);
#line 503 "../src/taquin-view.vala"
					_tmp30_ = _tmp29_;
#line 503 "../src/taquin-view.vala"
					game_request_move (_tmp26_, self->priv->x_arrow, _tmp30_, TRUE);
#line 503 "../src/taquin-view.vala"
					break;
#line 2028 "taquin-view.c"
				}
			}
		} else {
#line 499 "../src/taquin-view.vala"
			switch (0) {
#line 2034 "taquin-view.c"
				default:
				{
#line 504 "../src/taquin-view.vala"
					result = FALSE;
#line 504 "../src/taquin-view.vala"
					_g_free0 (k_name);
#line 504 "../src/taquin-view.vala"
					return result;
#line 2043 "taquin-view.c"
				}
			}
		}
	}
#line 507 "../src/taquin-view.vala"
	_tmp33_ = k_name;
#line 507 "../src/taquin-view.vala"
	if (g_strcmp0 (_tmp33_, "space") == 0) {
#line 507 "../src/taquin-view.vala"
		_tmp32_ = TRUE;
#line 2054 "taquin-view.c"
	} else {
		const gchar* _tmp34_;
#line 507 "../src/taquin-view.vala"
		_tmp34_ = k_name;
#line 507 "../src/taquin-view.vala"
		_tmp32_ = g_strcmp0 (_tmp34_, "KP_Enter") == 0;
#line 2061 "taquin-view.c"
	}
#line 507 "../src/taquin-view.vala"
	if (_tmp32_) {
#line 507 "../src/taquin-view.vala"
		_tmp31_ = TRUE;
#line 2067 "taquin-view.c"
	} else {
		const gchar* _tmp35_;
#line 507 "../src/taquin-view.vala"
		_tmp35_ = k_name;
#line 507 "../src/taquin-view.vala"
		_tmp31_ = g_strcmp0 (_tmp35_, "Return") == 0;
#line 2074 "taquin-view.c"
	}
#line 507 "../src/taquin-view.vala"
	if (_tmp31_) {
#line 2078 "taquin-view.c"
		Game* _tmp36_;
		Game* _tmp37_;
#line 509 "../src/taquin-view.vala"
		_tmp36_ = taquin_view_get_game (self);
#line 509 "../src/taquin-view.vala"
		_tmp37_ = _tmp36_;
#line 509 "../src/taquin-view.vala"
		game_request_move (_tmp37_, self->priv->x_arrow, self->priv->y_arrow, TRUE);
#line 510 "../src/taquin-view.vala"
		result = TRUE;
#line 510 "../src/taquin-view.vala"
		_g_free0 (k_name);
#line 510 "../src/taquin-view.vala"
		return result;
#line 2093 "taquin-view.c"
	}
#line 512 "../src/taquin-view.vala"
	_tmp38_ = k_name;
#line 512 "../src/taquin-view.vala"
	_tmp39_ = _tmp38_;
#line 512 "../src/taquin-view.vala"
	_tmp41_ = (NULL == _tmp39_) ? 0 : g_quark_from_string (_tmp39_);
#line 512 "../src/taquin-view.vala"
	if (_tmp41_ == ((0 != _tmp40_label0) ? _tmp40_label0 : (_tmp40_label0 = g_quark_from_static_string ("Left")))) {
#line 512 "../src/taquin-view.vala"
		switch (0) {
#line 2105 "taquin-view.c"
			default:
			{
#line 513 "../src/taquin-view.vala"
				if (((gint) self->priv->x_arrow) > 0) {
#line 2110 "taquin-view.c"
					gint8 _tmp42_;
#line 513 "../src/taquin-view.vala"
					_tmp42_ = self->priv->x_arrow;
#line 513 "../src/taquin-view.vala"
					self->priv->x_arrow = _tmp42_ - 1;
#line 2116 "taquin-view.c"
				}
#line 513 "../src/taquin-view.vala"
				break;
#line 2120 "taquin-view.c"
			}
		}
	} else if (_tmp41_ == ((0 != _tmp40_label1) ? _tmp40_label1 : (_tmp40_label1 = g_quark_from_static_string ("Right")))) {
#line 512 "../src/taquin-view.vala"
		switch (0) {
#line 2126 "taquin-view.c"
			default:
			{
				Game* _tmp43_;
				Game* _tmp44_;
				gint8 _tmp45_;
				gint8 _tmp46_;
#line 514 "../src/taquin-view.vala"
				_tmp43_ = taquin_view_get_game (self);
#line 514 "../src/taquin-view.vala"
				_tmp44_ = _tmp43_;
#line 514 "../src/taquin-view.vala"
				_tmp45_ = game_get_size (_tmp44_);
#line 514 "../src/taquin-view.vala"
				_tmp46_ = _tmp45_;
#line 514 "../src/taquin-view.vala"
				if (((gint) self->priv->x_arrow) < (_tmp46_ - 1)) {
#line 2143 "taquin-view.c"
					gint8 _tmp47_;
#line 514 "../src/taquin-view.vala"
					_tmp47_ = self->priv->x_arrow;
#line 514 "../src/taquin-view.vala"
					self->priv->x_arrow = _tmp47_ + 1;
#line 2149 "taquin-view.c"
				}
#line 514 "../src/taquin-view.vala"
				break;
#line 2153 "taquin-view.c"
			}
		}
	} else if (_tmp41_ == ((0 != _tmp40_label2) ? _tmp40_label2 : (_tmp40_label2 = g_quark_from_static_string ("Up")))) {
#line 512 "../src/taquin-view.vala"
		switch (0) {
#line 2159 "taquin-view.c"
			default:
			{
#line 515 "../src/taquin-view.vala"
				if (((gint) self->priv->y_arrow) > 0) {
#line 2164 "taquin-view.c"
					gint8 _tmp48_;
#line 515 "../src/taquin-view.vala"
					_tmp48_ = self->priv->y_arrow;
#line 515 "../src/taquin-view.vala"
					self->priv->y_arrow = _tmp48_ - 1;
#line 2170 "taquin-view.c"
				}
#line 515 "../src/taquin-view.vala"
				break;
#line 2174 "taquin-view.c"
			}
		}
	} else if (_tmp41_ == ((0 != _tmp40_label3) ? _tmp40_label3 : (_tmp40_label3 = g_quark_from_static_string ("Down")))) {
#line 512 "../src/taquin-view.vala"
		switch (0) {
#line 2180 "taquin-view.c"
			default:
			{
				Game* _tmp49_;
				Game* _tmp50_;
				gint8 _tmp51_;
				gint8 _tmp52_;
#line 516 "../src/taquin-view.vala"
				_tmp49_ = taquin_view_get_game (self);
#line 516 "../src/taquin-view.vala"
				_tmp50_ = _tmp49_;
#line 516 "../src/taquin-view.vala"
				_tmp51_ = game_get_size (_tmp50_);
#line 516 "../src/taquin-view.vala"
				_tmp52_ = _tmp51_;
#line 516 "../src/taquin-view.vala"
				if (((gint) self->priv->y_arrow) < (_tmp52_ - 1)) {
#line 2197 "taquin-view.c"
					gint8 _tmp53_;
#line 516 "../src/taquin-view.vala"
					_tmp53_ = self->priv->y_arrow;
#line 516 "../src/taquin-view.vala"
					self->priv->y_arrow = _tmp53_ + 1;
#line 2203 "taquin-view.c"
				}
#line 516 "../src/taquin-view.vala"
				break;
#line 2207 "taquin-view.c"
			}
		}
	} else {
#line 512 "../src/taquin-view.vala"
		switch (0) {
#line 2213 "taquin-view.c"
			default:
			{
#line 517 "../src/taquin-view.vala"
				result = FALSE;
#line 517 "../src/taquin-view.vala"
				_g_free0 (k_name);
#line 517 "../src/taquin-view.vala"
				return result;
#line 2222 "taquin-view.c"
			}
		}
	}
#line 519 "../src/taquin-view.vala"
	self->priv->draw_lights = TRUE;
#line 520 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 521 "../src/taquin-view.vala"
	result = TRUE;
#line 521 "../src/taquin-view.vala"
	_g_free0 (k_name);
#line 521 "../src/taquin-view.vala"
	return result;
#line 2236 "taquin-view.c"
}

static gint
taquin_view_get_x_offset (TaquinView* self)
{
	gint result;
#line 43 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/taquin-view.vala"
	result = ((gtk_widget_get_allocated_width ((GtkWidget*) self) - self->priv->board_size) / 2) - self->priv->grid_border_main;
#line 43 "../src/taquin-view.vala"
	return result;
#line 2249 "taquin-view.c"
}

static gint
taquin_view_get_y_offset (TaquinView* self)
{
	gint result;
#line 44 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/taquin-view.vala"
	result = ((gtk_widget_get_allocated_height ((GtkWidget*) self) - self->priv->board_size) / 2) - self->priv->grid_border_main;
#line 44 "../src/taquin-view.vala"
	return result;
#line 2262 "taquin-view.c"
}

static Game*
taquin_view_get_game (TaquinView* self)
{
	Game* result;
	Game* _tmp0_;
	Game* _tmp1_;
#line 85 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../src/taquin-view.vala"
	_tmp0_ = self->priv->_game;
#line 85 "../src/taquin-view.vala"
	if (_tmp0_ == NULL) {
#line 85 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2279 "taquin-view.c"
	}
#line 85 "../src/taquin-view.vala"
	_tmp1_ = self->priv->_game;
#line 85 "../src/taquin-view.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_GAME, Game);
#line 85 "../src/taquin-view.vala"
	return result;
#line 2287 "taquin-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 91 "../src/taquin-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 2295 "taquin-view.c"
}

static void
_taquin_view_move_cb_game_move (Game* _sender,
                                gboolean x_axis,
                                gint8 number,
                                gint8 x_gap,
                                gint8 y_gap,
                                guint moves_count,
                                gboolean disable_animation,
                                gpointer self)
{
#line 102 "../src/taquin-view.vala"
	taquin_view_move_cb ((TaquinView*) self, x_axis, number, x_gap, y_gap, moves_count, disable_animation);
#line 2310 "taquin-view.c"
}

static void
_taquin_view_complete_cb_game_complete (Game* _sender,
                                        gpointer self)
{
#line 103 "../src/taquin-view.vala"
	taquin_view_complete_cb ((TaquinView*) self);
#line 2319 "taquin-view.c"
}

void
taquin_view_set_game (TaquinView* self,
                      Game* value)
{
	Game* _tmp0_;
	Game* _tmp2_;
	Game* _tmp3_;
	Game* _tmp4_;
	Game* _tmp5_;
#line 86 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/taquin-view.vala"
	_tmp0_ = self->priv->_game;
#line 88 "../src/taquin-view.vala"
	if (_tmp0_ != NULL) {
#line 2337 "taquin-view.c"
		Game* _tmp1_;
#line 89 "../src/taquin-view.vala"
		_tmp1_ = self->priv->_game;
#line 89 "../src/taquin-view.vala"
		g_signal_handlers_disconnect_by_func (_tmp1_, NULL, self);
#line 2343 "taquin-view.c"
	}
#line 91 "../src/taquin-view.vala"
	_tmp2_ = _g_object_ref0 (value);
#line 91 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 91 "../src/taquin-view.vala"
	self->priv->_game = _tmp2_;
#line 92 "../src/taquin-view.vala"
	_tmp3_ = self->priv->_game;
#line 92 "../src/taquin-view.vala"
	if (_tmp3_ == NULL) {
#line 93 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2357 "taquin-view.c"
	}
#line 95 "../src/taquin-view.vala"
	self->priv->animate = FALSE;
#line 96 "../src/taquin-view.vala"
	self->priv->finished = FALSE;
#line 97 "../src/taquin-view.vala"
	self->priv->animate_end = FALSE;
#line 98 "../src/taquin-view.vala"
	self->priv->animation_end_offset = (gdouble) 0;
#line 99 "../src/taquin-view.vala"
	self->priv->draw_lights = FALSE;
#line 100 "../src/taquin-view.vala"
	self->priv->x_arrow = (gint8) 0;
#line 101 "../src/taquin-view.vala"
	self->priv->y_arrow = (gint8) 0;
#line 102 "../src/taquin-view.vala"
	_tmp4_ = self->priv->_game;
#line 102 "../src/taquin-view.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_GAME, Game), "move", (GCallback) _taquin_view_move_cb_game_move, self, 0);
#line 103 "../src/taquin-view.vala"
	_tmp5_ = self->priv->_game;
#line 103 "../src/taquin-view.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_GAME, Game), "complete", (GCallback) _taquin_view_complete_cb_game_complete, self, 0);
#line 104 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2383 "taquin-view.c"
}

static const gchar*
taquin_view_get_theme (TaquinView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 111 "../src/taquin-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 111 "../src/taquin-view.vala"
	_tmp0_ = self->priv->_theme;
#line 111 "../src/taquin-view.vala"
	if (_tmp0_ == NULL) {
#line 111 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2400 "taquin-view.c"
	}
#line 111 "../src/taquin-view.vala"
	_tmp1_ = self->priv->_theme;
#line 111 "../src/taquin-view.vala"
	result = (const gchar*) _tmp1_;
#line 111 "../src/taquin-view.vala"
	return result;
#line 2408 "taquin-view.c"
}

void
taquin_view_set_theme (TaquinView* self,
                       const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 112 "../src/taquin-view.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/taquin-view.vala"
	_tmp0_ = g_strdup (value);
#line 114 "../src/taquin-view.vala"
	_g_free0 (self->priv->_theme);
#line 114 "../src/taquin-view.vala"
	self->priv->_theme = _tmp0_;
#line 115 "../src/taquin-view.vala"
	_tmp1_ = self->priv->_theme;
#line 115 "../src/taquin-view.vala"
	if (_tmp1_ == NULL) {
#line 116 "../src/taquin-view.vala"
		g_assert_not_reached ();
#line 2431 "taquin-view.c"
	}
#line 117 "../src/taquin-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 117 "../src/taquin-view.vala"
	self->priv->tiles_pattern = NULL;
#line 118 "../src/taquin-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 2439 "taquin-view.c"
}

static void
taquin_view_class_init (TaquinViewClass * klass,
                        gpointer klass_data)
{
#line 32 "../src/taquin-view.vala"
	taquin_view_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/taquin-view.vala"
	g_type_class_adjust_private_offset (klass, &TaquinView_private_offset);
#line 32 "../src/taquin-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) taquin_view_real_draw;
#line 32 "../src/taquin-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) taquin_view_real_button_press_event;
#line 32 "../src/taquin-view.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) taquin_view_real_key_press_event;
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_taquin_view_get_property;
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_taquin_view_set_property;
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (klass)->finalize = taquin_view_finalize;
#line 32 "../src/taquin-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAQUIN_VIEW_GAME_PROPERTY, taquin_view_properties[TAQUIN_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 32 "../src/taquin-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAQUIN_VIEW_THEME_PROPERTY, taquin_view_properties[TAQUIN_VIEW_THEME_PROPERTY] = g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 2466 "taquin-view.c"
}

static void
taquin_view_instance_init (TaquinView * self,
                           gpointer klass)
{
#line 32 "../src/taquin-view.vala"
	self->priv = taquin_view_get_instance_private (self);
#line 37 "../src/taquin-view.vala"
	self->priv->grid_border_thin = 6;
#line 57 "../src/taquin-view.vala"
	self->priv->x_arrow = (gint8) 0;
#line 58 "../src/taquin-view.vala"
	self->priv->y_arrow = (gint8) 0;
#line 59 "../src/taquin-view.vala"
	self->priv->draw_lights = FALSE;
#line 62 "../src/taquin-view.vala"
	self->priv->render_size = 0;
#line 63 "../src/taquin-view.vala"
	self->priv->tiles_pattern = NULL;
#line 66 "../src/taquin-view.vala"
	self->priv->animate = FALSE;
#line 72 "../src/taquin-view.vala"
	self->priv->animate_end = FALSE;
#line 73 "../src/taquin-view.vala"
	self->priv->finished = FALSE;
#line 82 "../src/taquin-view.vala"
	self->priv->_game = NULL;
#line 108 "../src/taquin-view.vala"
	self->priv->_theme = NULL;
#line 2497 "taquin-view.c"
}

static void
taquin_view_finalize (GObject * obj)
{
	TaquinView * self;
#line 32 "../src/taquin-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAQUIN_VIEW, TaquinView);
#line 63 "../src/taquin-view.vala"
	_cairo_pattern_destroy0 (self->priv->tiles_pattern);
#line 82 "../src/taquin-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 108 "../src/taquin-view.vala"
	_g_free0 (self->priv->_theme);
#line 32 "../src/taquin-view.vala"
	G_OBJECT_CLASS (taquin_view_parent_class)->finalize (obj);
#line 2514 "taquin-view.c"
}

GType
taquin_view_get_type (void)
{
	static volatile gsize taquin_view_type_id__volatile = 0;
	if (g_once_init_enter (&taquin_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TaquinViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) taquin_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TaquinView), 0, (GInstanceInitFunc) taquin_view_instance_init, NULL };
		GType taquin_view_type_id;
		taquin_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "TaquinView", &g_define_type_info, 0);
		TaquinView_private_offset = g_type_add_instance_private (taquin_view_type_id, sizeof (TaquinViewPrivate));
		g_once_init_leave (&taquin_view_type_id__volatile, taquin_view_type_id);
	}
	return taquin_view_type_id__volatile;
}

static void
_vala_taquin_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	TaquinView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAQUIN_VIEW, TaquinView);
#line 32 "../src/taquin-view.vala"
	switch (property_id) {
#line 32 "../src/taquin-view.vala"
		case TAQUIN_VIEW_GAME_PROPERTY:
#line 32 "../src/taquin-view.vala"
		g_value_set_object (value, taquin_view_get_game (self));
#line 32 "../src/taquin-view.vala"
		break;
#line 32 "../src/taquin-view.vala"
		case TAQUIN_VIEW_THEME_PROPERTY:
#line 32 "../src/taquin-view.vala"
		g_value_set_string (value, taquin_view_get_theme (self));
#line 32 "../src/taquin-view.vala"
		break;
#line 2553 "taquin-view.c"
		default:
#line 32 "../src/taquin-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/taquin-view.vala"
		break;
#line 2559 "taquin-view.c"
	}
}

static void
_vala_taquin_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	TaquinView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAQUIN_VIEW, TaquinView);
#line 32 "../src/taquin-view.vala"
	switch (property_id) {
#line 32 "../src/taquin-view.vala"
		case TAQUIN_VIEW_GAME_PROPERTY:
#line 32 "../src/taquin-view.vala"
		taquin_view_set_game (self, g_value_get_object (value));
#line 32 "../src/taquin-view.vala"
		break;
#line 32 "../src/taquin-view.vala"
		case TAQUIN_VIEW_THEME_PROPERTY:
#line 32 "../src/taquin-view.vala"
		taquin_view_set_theme (self, g_value_get_string (value));
#line 32 "../src/taquin-view.vala"
		break;
#line 2585 "taquin-view.c"
		default:
#line 32 "../src/taquin-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/taquin-view.vala"
		break;
#line 2591 "taquin-view.c"
	}
}

